# cave
# de-port by kimstudio for BX32 from https://www.lexaloffle.com/bbs/?pid=105430#p

Dim Type(x, y, dy, rise, fall, dead, speed, score, jump_velocity) player
Dim caveu(192)
Dim caved(192)

textcolor = bx_rgb(178,0,255)
cavecolor = bx_rgb(80, 80, 80)
top = 60 
btm = 144-60
gravity=0.2
game_over = true
speed_step = 1 
point_step = 1500 
next_step = point_step

bx_sfxset("cavesfx1.mp3", 1)
bx_sfxset("cavesfx2.mp3", 2)

make_player
make_cave

sub make_player
	player.x=40
	player.y=72
	player.dy=0
	player.rise=1
	player.fall=2
	player.dead=3
	player.speed=2
	player.score=0
	player.jump_velocity=3
end sub

sub draw_player
	if game_over then
		bx_spr(player.dead,player.x,player.y)
	else if(player.dy < 0) then
		bx_spr(player.rise,player.x,player.y)
	else
		bx_spr(player.fall, player.x, player.y)
	end if
end sub

sub move_player
	player.dy = player.dy + gravity
	if bx_btnp(2) then
		bx_sfx(1)
		player.dy = 0
		player.dy = player.dy - player.jump_velocity
	end if
	player.y = player.y+player.dy
	player.score = player.score+int(player.speed)
	
end sub

sub check_hit
	for i=player.x to player.x+7
		if (caveu(i+1)>player.y or caved(i+1)<player.y+7) then
				game_over=true
				bx_sfx(2)
		end if
	next
end sub

sub speed_modifier
	if (next_step < player.score) then
		player.speed = player.speed + speed_step
		next_step = player.score + point_step
		point_step = point_step + point_step / 2 
	end if
end sub
# ---------------------------------
sub mid(a, b, c)
    m = a
	if a < b then
		if a < c then
			if b < c then
				m = b
			else
				m = c
			end if
		else
			m = a
		end if
	else
		if b < c then
			if a < c then
				m = a
			else
				m = c
			end if
		else
			m = b
		end if
	end if
	return m
end sub

sub make_cave
	caveu(0) = 5
	caved(0) = 119
	for i = 1 to 191 
		up = int(bx_rnd(0,7)-3)
		dwn = int(bx_rnd(0,7)-3)
		caveu(i) = mid(3,caveu(i-1)+up,top)
		caved(i) = mid(btm,caved(i-1)+dwn,144)
	next
end sub
 
sub update_cave
	for i= 0 to 191-player.speed
		caveu(i) = caveu(i+player.speed)
		caved(i) = caved(i+player.speed)
	next

	for i = 191-player.speed to 191 
		up = int(bx_rnd(0,7)-3)
		dwn = int(bx_rnd(0,7)-3)
		caveu(i) = mid(3,caveu(i-1)+up,top)
		caved(i) = mid(btm,caved(i-1)+dwn,144)
	next
end sub

sub draw_cave
	for i= 0 to 191 
		bx_line(i, 0, i, caveu(i), cavecolor)
		bx_line(i,143,i, caved(i), cavecolor)
	next
end sub
# ---------------------------------
sub draw_cover
	draw_cave
	bx_sprx(46,35,0,105,98,23)
	bx_text("DE-PORT BY KIM", 54, 76, textcolor)
	bx_text("PRESS UP TO START/JUMP", 36, 88, textcolor)
	bx_spr(player.fall, 92, 60)
	bx_text("SCORE:" & player.score, 72, 100, textcolor)
end sub
# ---------------------------------
sub update
	if not(game_over) then
		update_cave
		move_player
		check_hit
		speed_modifier
	else
		if bx_btnp(2) then
			game_over = false
			make_player
		end if
	end if
end sub

sub draw
	bx_cls(bx_rgb(255,255,255))
	if game_over then
		draw_cave
		draw_cover
	else
		draw_cave
		draw_player
		bx_text("SCORE:" & player.score, 1, 133, textcolor)
	end if
end sub
